macroScript ViewportsLayout category:"Bobo_s Tools" tooltip:"Viewport Layouts Manager" --Icon:#("bobomacro",6) 
(  
------------------------------------------ 
--ViewportsLayout MACROSCRIPT v 0.4 
--Created:5/11/99 
--Edited:09/17/02 
--by Borislav Petrov 
--bobo@email.archlab.tuwien.ac.at 
------------------------------------------ 
--This is a very rough version  
--of a Viewport Layout Saver.
--Does NOT work with TrackView/SchematicView/AssetsMan. 
------------------------------------------
--Version 0.4 - max 5 compatible
--Version 0.3 Saves full Camera names in both VPL and
--Macro names. Allows for multiple identical layouts 
--with just different cameras displayed...
------------------------------------------  
global nf 
local vl_main, l_name, s_name, layout_type
local v1_type, v2_type, v3_type, v4_type 
local c1_name, c2_name, c3_name, c4_name

fn update_list = 
( 	
	get_files = getfiles (scriptspath+"*.vpl") 	
	names_array = #() 	
	for i in get_files do  	
	(
		append names_array (getfilenamefile i) 	
	)
 	vl_main.layout_list.items = names_array
)  

local names_array = #() 
get_files = getfiles (scriptspath+"*.vpl") 
for i in get_files do append names_array (filenamefrompath i) 

rollout vl_main "Viewport Layout" 
(
button save_layout "Save" width:40 height:20 across:4 pos:[5,6] tooltip:"Save Current Layout"
button create_macro "M" width:20 height:20  pos:[45,6] tooltip:"Create MacroScript"
button delete_layout "X" width:20 height:20 pos:[67,6] tooltip:"Delete Layout Definition" 
dropdownlist layout_list items:#() width:320 pos:[90,6] 

fn get_out_name =
(
	v1_type = undefined
	v2_type = undefined
	v3_type = undefined
	v4_type = undefined
	c1_name = ""
	c2_name = ""
	c3_name = ""
	c4_name = ""
	
	
	layout_type = viewport.getLayout ()
	if layout_type == #layout_1 then 
	(
		l_name = "V1 " 
		s_name = "V1 "
	)
	if layout_type == #layout_2v then 
	(
		l_name = "V2 Vert " 
		s_name = "V2 V "
	)
	if layout_type == #layout_2h then 
	(
		l_name = "V2 Hor " 
		s_name = "V2 H "
	)
	if layout_type == #layout_2ht then 
	(
		l_name = "V2 Hor TopSmall " 
		s_name = "V2 HT "
	)
	if layout_type == #layout_2hb then 
	(
		l_name = "V2 Hor TopBig " 
		s_name = "V2 HB "
	)
	if layout_type == #layout_3vl then 
	(
		l_name = "V3 2Left 1Right " 
		s_name = "V3 VL "
	)
	if layout_type == #layout_3vr then 
	(
		l_name = "V3 1Left 2Right " 
		s_name = "V3 VR "
	)
	if layout_type == #layout_3ht then 
	(
		l_name = "V3 2Top 1Bottom " 
		s_name = "V3 HT "
	)
	if layout_type == #layout_3hb then 
	(
		l_name = "V3 1Top 2Bottom " 
		s_name = "V3 HB "
	)
	if layout_type == #layout_4 then 
	(
		l_name = "V4 Same " 
		s_name = "V4 S "
	)
	if layout_type == #layout_4vl then 
	(
		l_name = "V4 3Left 1Right " 
		s_name = "V4 VL "
	)
	if layout_type == #layout_4vr then 
	(
		l_name = "V4 1Left 3Right " 
		s_name = "V4 VR "
	)
	if layout_type == #layout_4ht then 
	(
		l_name = "V4 3Top 1Bottom " 
		s_name = "V4 HT "
	)
	if layout_type == #layout_4hb then 
	(
		l_name = "V4 1Top 3Bottom " 
		s_name = "V4 HB "
	)
	
	try
	(
		viewport.activeViewport = 1
		
		v1_type = viewport.getType ()
		c1 = viewport.getCamera ()
		if c1 != undefined then c1_name = c1.name
		
		
		viewport.activeViewport = 2
		
		v2_type = viewport.getType ()
		c2 = viewport.getCamera ()
		if c2 != undefined then c2_name = c2.name
		
		viewport.activeViewport = 3
		
		v3_type = viewport.getType ()
		c3 = viewport.getCamera ()
		if c3 != undefined then c3_name = c3.name
		
		viewport.activeViewport = 4
		
		v4_type = viewport.getType ()
		c4 = viewport.getCamera ()
		if c4 != undefined then c4_name = c4.name
	)
	catch ()
	
	v1_s = v1_type as string
	v2_s = v2_type as string
	v3_s = v3_type as string
	v4_s = v4_type as string
	
	if v1_type != undefined then 
	(
		if c1 != undefined then 
		(
				l_name += c1.name + " "
				s_name += c1.name + "_"
			)
			else
			(
				l_name += substring v1_s 6 ((v1_s).count-5) + " "
				s_name += substring v1_s 6 1		
			)
		)
		
	if v2_type != undefined then 
	(
		if c2 != undefined then 
		(
			l_name += c2.name + " "
			s_name += c2.name + "_"
		)
		else
		(
			l_name += substring v2_s 6 ((v2_s).count-5) + " "
			s_name += substring v2_s 6 1
		)
	)
		
	if v3_type != undefined then 
	(
		if c3 != undefined then 
		(
			l_name += c3.name + " "
			s_name += c3.name + "_"
		)
		else
		(
			l_name += substring v3_s 6 ((v3_s).count-5) + " "
			s_name += substring v3_s 6 1
		)
	)
		
	if v4_type != undefined then 
	(
		if c4 != undefined then 
		(
			l_name += c4.name + " "
			s_name += c4.name + "_"
		)
		else
		(
			l_name += substring v4_s 6 ((v4_s).count-5) + " "
			s_name += substring v4_s 6 1
		)
	)
	
)
on save_layout pressed do 
( 	
	get_out_name () 	 	
	out_file = createfile (scriptspath+l_name+".vpl") 	
	format "%\n" "Viewport Layout Version 1.0" to:out_file 	
	format "%\n" layout_type to:out_file 	
	format "%\n" v1_type to:out_file
	format "%\n" c1_name to:out_file
	format "%\n" v2_type to:out_file
	format "%\n" c2_name to:out_file
	format "%\n" v3_type to:out_file
	format "%\n" c3_name to:out_file
	format "%\n" v4_type to:out_file
	format "%\n" c4_name to:out_file
	close out_file 	 	
	update_list () 
)

on create_macro pressed do
(
	get_out_name()
	out_file = createfile (cui.getDir()+"\\macroscripts\\"+l_name+".mcr")
	s_name_fix = ""
	for i = 1 to s_name.count do
	(
		if substring s_name i 1 != " " then s_name_fix += substring s_name i 1 else s_name_fix += "_"
	)
	
	txt = "MacroScript "+ s_name_fix +" category:\"Viewports\" tooltip:\""+l_name+"\" ( "
	format "%\n" txt to:out_file
	
	format "%\n" "--Generated Automatically by ViewportsLayout Script" to:out_file
	
	txt = "viewport.setlayout #"+layout_type as string
	format "%\n" txt to:out_file
	
	txt = "try ("
	format "%\n" txt to:out_file
	
	txt = "viewport.activeViewport = 1"
	format "%\n" txt to:out_file
	
	if v1_type !=#view_camera then
	(
		txt = "viewport.setType #"+v1_type as string
		format "%\n" txt to:out_file
	)
	else
	(
		format "%\n" "viewport.setType #view_persp_user" to:out_file
		txt = "viewport.setCamera $"+c1_name
		format "%\n" txt to:out_file
	)
	
	txt = ")catch()"
	format "%\n" txt to:out_file
	
	txt = "try ("
	format "%\n" txt to:out_file
	
	
	txt = "viewport.activeViewport = 2"
	format "%\n" txt to:out_file
	
	if v2_type !=#view_camera then
	(
		txt = "viewport.setType #"+v2_type as string
		format "%\n" txt to:out_file
	)
	else
	(
		format "%\n" "viewport.setType #view_persp_user" to:out_file
		txt = "viewport.setCamera $"+c2_name
		format "%\n" txt to:out_file
	)
	
	txt = ")catch()"
	format "%\n" txt to:out_file
	
	txt = "try ("
	format "%\n" txt to:out_file
	
	
	txt = "viewport.activeViewport = 3"
	format "%\n" txt to:out_file
	
	if v3_type !=#view_camera then
	(
		txt = "viewport.setType #"+v3_type as string
		format "%\n" txt to:out_file
	)
	else
	(
		format "%\n" "viewport.setType #view_persp_user" to:out_file
		txt = "viewport.setCamera $"+c3_name
		format "%\n" txt to:out_file
	)
	
	txt = ")catch()"
	format "%\n" txt to:out_file
	
	txt = "try ("
	format "%\n" txt to:out_file
	
	txt = "viewport.activeViewport = 4"
	format "%\n" txt to:out_file
	
	if v4_type !=#view_camera then
	(
		txt = "viewport.setType #"+v4_type as string
		format "%\n" txt to:out_file
	)
	else
	(
		format "%\n" "viewport.setType #view_persp_user" to:out_file
		txt = "viewport.setCamera $"+c4_name
		format "%\n" txt to:out_file
	)
	
	
	txt = ")catch())"
	format "%\n" txt to:out_file
	close out_file
	in_file = openfile (cui.getDir()+"\\macroscripts\\"+l_name+".mcr")
	execute in_file
	close in_file
) 
on delete_layout pressed do 
( 	
	q = querybox "Are you sure you want to DELETE\nthe layout file?" title:"VPLayout" 	
	if q then  	
	( 		
		deletefile (scriptspath+layout_list.items[layout_list.selection]+".vpl") 		
		layout_list.selection -= 1 		
		update_list () 	
	) 
)  

on layout_list selected itm do 
( 	
	in_file = openfile (scriptspath+layout_list.items[itm]+".vpl") 	
	str = readline in_file --version control (not used yet) 	 	
	str = readline in_file 	
	viewport.setLayout (execute str) 	 	
	try 	
	( 		
		viewport.activeViewport = 1 		
		str = readline in_file
	
		if str != "undefined" and str!="#view_camera" then viewport.setType (execute str)
		str = readline in_file
		if str != "" then 
		(
			viewport.setType #view_persp_user
			c_node = execute ("$"+str)
			if cameras.count > 0 then viewport.setCamera c_node
			max views redraw
		) 	
	)catch()
	
	try
	( 		
		viewport.activeViewport = 2 		
		str = readline in_file
		
		if str != "undefined" and str!="#view_camera" then viewport.setType (execute str)
		str = readline in_file
		if str != "" then 
		(
			viewport.setType #view_persp_user
			c_node = execute ("$"+str)
			if cameras.count > 0 then viewport.setCamera c_node
			max views redraw
		)
	)catch()
	
	try
	(
		viewport.activeViewport = 3 		
		str = readline in_file
		
		if str != "undefined" and str!="#view_camera" then viewport.setType (execute str)
		str = readline in_file
		if str != "" then 
		(
			viewport.setType #view_persp_user
			c_node = execute ("$"+str)
			if cameras.count > 0 then viewport.setCamera c_node
			max views redraw
		)
	)catch()
	
	try
	(
		viewport.activeViewport = 4 		
		str = readline in_file 		
		if str != "undefined" and str!="#view_camera" then viewport.setType (execute str)
		str = readline in_file
		if str != "" then 
		(
			viewport.setType #view_persp_user
			c_node = execute ("$"+str)
			if cameras.count > 0 then viewport.setCamera c_node
			max views redraw
		)
	) 	catch () 	 	
	close in_file 	 	
) 
)--end rollout  
if nf != undefined then closerolloutfloater nf 
nf = newrolloutfloater "Viewports Layout" 440 96 100 100 
addrollout vl_main nf 
update_list () 
)--end script
